/*! @file sse_types.h

*  @brief Mesh tools
*
*  @version 1.0.0
*
*  (C) Copyright 2017 GoPro Inc (http://gopro.com/).
*
*  Licensed under either:
*  - Apache License, Version 2.0, http://www.apache.org/licenses/LICENSE-2.0  
*  - MIT license, http://opensource.org/licenses/MIT
*  at your option.
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*
*/

#ifndef SSE_TYPES_H
#define SSE_TYPES_H

#include "emmintrin.h"

typedef union
{
    unsigned long long ldata[2];
    unsigned int       idata[4];
    unsigned short     sdata[8];
    unsigned char      cdata[16];
    __m128i            m128;
} m128i;

#endif /* SSE_TYPES_H */

